<?php
$time = (7*86400);
$audit = Dever::config('base')->audit;

$status = Dever::config('base')->status;

# 获取小刊分类权限
$auth = Dever::tops();
$cate = function() use ($auth)
{
	$array = array();
	if ($auth) {
		$info = Dever::db('magazine/cate')->getIds(array('ids' => $auth));
	} else {
		$info = Dever::db('magazine/cate')->state();
	}
	
	if($info)
	{
		$array += $info;
	}
	return $array;
};


$share = array
(
	1 => '显示',
	2 => '不显示',
);

$ranking = array
(
	1 => '开启',
	2 => '不开启',
);

$sell = array
(
	1 => '开启',
	2 => '不开启',
);

$buy = array
(
	1 => '收费',
	2 => '免费',
);

$hot = array
(
	1 => '热门',
	2 => '普通',
);


$page = 15;

# 常用的col
$col = '*';

$config = array
(
	# 表名
	'name' => 'info',
	# 显示给用户看的名称
	'lang' => '电子刊管理',
	'order' => 100,
	'ends' => array
	(
		'insert' => 'magazine/lib/manage.setInfoCache',
		'update' => 'magazine/lib/manage.setInfoCache',
		'update_status' => 'magazine/lib/manage.setInfoCache',
	),

	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'list'		=> true,
		),

		'name'		=> array
		(
			'type' 		=> 'varchar-180',
			'name' 		=> '标题',
			'default' 	=> '',
			'desc' 		=> '标题',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
		),

		'subname'		=> array
		(
			'type' 		=> 'varchar-80',
			'name' 		=> '子标题-一般为电子刊的期数，如第1期',
			'default' 	=> '',
			'desc' 		=> '子标题',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			//'list'		=> true,
		),

		'cate_id'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '分类',
			'default' 	=> '1',
			'desc' 		=> '分类',
			'match' 	=> 'is_numeric',
			'update'	=> 'select',
			'option'	=> $cate,
			'search'	=> 'select',
			//'list'		=> true,
		),

		'pic_cover'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '封面图-图片尺寸660*660px或等比尺寸，上传大小不能超过2M，支持JPG、PNG、GIF格式，建议上传JPG格式',
			'default' 	=> '',
			'desc' 		=> '封面图',
			'match' 	=> 'is_string',
			'update'	=> 'image',
			'key' 		=> '1',
			'place'		=> '660*660',
		),

		'pic_bg'		=> array
		(
			'type' 		=> 'text-255',
			'name' 		=> '全屏背景图-图片尺寸750*1386px或等比尺寸，上传大小不能超过2M，支持JPG、PNG、GIF格式，建议上传JPG格式',
			'default' 	=> '',
			'desc' 		=> '全屏背景图',
			'match' 	=> 'is_string',
			'update'	=> 'images',
			'key' 		=> '1',
			'place'		=> '750*1386',
		),

		'bgmusic'		=> array
		(
			'type' 		=> 'varchar-800',
			'name' 		=> '背景音乐-音频格式mp3，上传大小不能超过100M',
			'default' 	=> '',
			'desc' 		=> '背景音乐',
			'match' 	=> 'option',
			'update'	=> 'upload',
			'key' 		=> '2',
			'place'		=> '150',
			'upload'	=> 'qiniu',
			'large' 	=> true,
			//不覆盖原文件，生成新文件
			'cover'		=> 2,
		),

		'pdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '发售时间',
			'match' 	=> array('is_numeric', time()),
			'default'	=> '',
			'desc' 		=> '',
			'update'	=> 'date',
			'callback'	=> 'maketime',
			'insert'	=> true,
			//'list'		=> 'date("Y-m-d H:i:s", {pdate})',
			'auth'		=> '"{pdate}" > 0',
		),

		'buy'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '是否收费',
			'default' 	=> '1',
			'desc' 		=> '是否收费',
			'match' 	=> 'option',
			'update'	=> 'radio',
			'option'	=> $buy,
			'control'	=> 'buy',
			//'list'		=> true,
			'search'	=> 'select',
		),

		'num_ding'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '订阅数',
			'default' 	=> '0',
			'desc' 		=> '请填写订阅数',
			'match' 	=> 'option',
			'search'	=> 'order',
		),

		'num_ratio_ding'		=> array
		(
			'type' 		=> 'varchar-20',
			'name' 		=> '订阅系数-系数不能小于等于0，支持两位小数，电子刊总订阅量=（用户当前订阅数+订阅基数）*订阅系数。',
			'default' 	=> '1',
			'desc' 		=> '手动增加订阅系数',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'show'		=> 'buy=1',
		),

		'num_add_ding'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '订阅基数',
			'default' 	=> '0',
			'desc' 		=> '手动增加阅读数',
			'match' 	=> 'option',
			'update'	=> 'text',
			'show'		=> 'buy=1',
		),

		'num_add_view'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '阅读数基数',
			'default' 	=> '0',
			'desc' 		=> '手动增加阅读数',
			'match' 	=> 'option',
			'update'	=> 'text',
		),

		'num_view'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '阅读数',
			'default' 	=> '0',
			'desc' 		=> '请填写阅读数',
			'match' 	=> 'option',
			'search'	=> 'order',
		),

		'num_add_up'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '收藏基数',
			'default' 	=> '0',
			'desc' 		=> '收藏基数',
			'match' 	=> 'option',
			//'update'	=> 'text',
		),
		
		'num_up'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '收藏数',
			'default' 	=> '0',
			'desc' 		=> '请填写收藏数',
			'match' 	=> 'option',
			//'search'	=> 'order',
			'list'		=> 'Dever::load("magazine/lib/manage.num?id={id}")',
			'list_name'	=> '统计数字',
		),

		'cash'      => array
        (
            'type'      => 'varchar-50',
            'name'      => '单本支付价格-单位元，直接填写数字即可',
            'default'   => '',
            'desc'      => '支付价格',
            'match'     => 'is_string',
            'update'    => 'text',
            'show'		=> 'buy=1',
        ),

        'buy_content'       => array
        (
            'type'      => 'text-255',
            'name'      => '购买说明',
            'default'   => "<p>
	1、门票使用成功后可直接点击【入界】查看万界志内容；&nbsp;
</p>
<p>
	2、万界志门票为虚拟商品，如无系统问题，使用后不可退款；
</p>
<p>
	&nbsp;3、购买多少张就会生成多少门票，每个门票只能被激活一次；
</p>
<p>
	&nbsp;4、当购买成功后，系统会自动使用一个门票；&nbsp;
</p>
<p>
	5、若您购买了多张门票，可将剩余门票赠送好友；
</p>
<p>
	&nbsp;6、如有其它问题可咨询在线客服。
</p>",
            'desc'      => '请输入内容',
            'match'     => 'is_string',
            'update'    => 'editor',
            'key'       => 1,
            'show'		=> 'buy=1',
        ),

        'score'         => array
        (
            'type'      => 'varchar-80',
            'name'      => '购买增加积分数-直接填写购买单本电子刊的积分数，设置之后，积分规则里的设置将失效，如果设置为0，则按照积分规则进行增加积分',
            'default'   => '20',
            'desc'      => '增加积分数',
            'match'     => 'is_string',
            'update'    => 'text',
            'show'		=> 'buy=1',
        ),

        'code_score'         => array
        (
            'type'      => 'varchar-80',
            'name'      => '使用门票增加积分数-直接填写使用门票首次进入电子刊增加的积分数，设置之后，积分规则里的设置将失效，如果设置为0，则按照积分规则进行增加积分',
            'default'   => '0',
            'desc'      => '使用门票增加积分数',
            'match'     => 'is_string',
            'update'    => 'text',
            'show'		=> 'buy=1',
        ),

        'code_parent_score'         => array
        (
            'type'      => 'varchar-80',
            'name'      => '使用门票增加分享者积分数-直接填写使用门票首次进入电子刊增加的分享者的积分数，设置之后，积分规则里的设置将失效，如果设置为0，则按照积分规则进行增加积分',
            'default'   => '10',
            'desc'      => '使用门票增加分享者积分数',
            'match'     => 'is_string',
            'update'    => 'text',
            'show'		=> 'buy=1',
        ),

        'audit'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '审核',
			'default' 	=> '1',
			'desc' 		=> '审核',
			'match' 	=> 'is_numeric',
			//'update'	=> 'select',
			'option'	=> $audit,
			//'search'	=> 'select',
			//'list'		=> true,
			//'edit'		=> true,
		),

		'status'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '上线状态',
			'default' 	=> '1',
			'desc' 		=> '上线状态',
			'match' 	=> 'is_numeric',
			//'update'	=> 'select',
			'option'	=> $status,
			'search'	=> 'select',
			'list'		=> true,
			'edit'		=> true,
		),

        'sell'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '是否开启分销',
			'default' 	=> '1',
			'desc' 		=> '是否开启分销',
			'match' 	=> 'option',
			'update'	=> 'radio',
			'option'	=> $sell,
			'list'		=> true,
			'search'	=> 'select',
			'edit'		=> true,
		),

        'ranking'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '是否开启排行榜',
			'default' 	=> '1',
			'desc' 		=> '是否开启排行榜',
			'match' 	=> 'option',
			'update'	=> 'radio',
			'option'	=> $ranking,
			'list'		=> true,
			'search'	=> 'select',
			'edit'		=> true,
		),

		'hot'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '是否热门电子刊',
			'default' 	=> '2',
			'desc' 		=> '是否热门电子刊',
			'match' 	=> 'option',
			//'update'	=> 'radio',
			'option'	=> $hot,
			'search'	=> 'select',
			'list'		=> true,
			'edit'		=> true,
		),

		'share'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '是否显示分享按钮',
			'default' 	=> '2',
			'desc' 		=> '是否显示分享按钮',
			'match' 	=> 'option',
			'update'	=> 'radio',
			'option'	=> $share,
			'control'	=> 'share',
		),

		'share_title'		=> array
		(
			'type' 		=> 'varchar-100',
			'name' 		=> '分享标题',
			'default' 	=> '',
			'desc' 		=> '分享标题',
			'match' 	=> 'option',
			'update'	=> 'text',
			'show'		=> 'share=1',
		),

		'share_pic'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '分享图片-图片尺寸570*570px或等比尺寸，上传大小不能超过2M，支持JPG、PNG、GIF格式，建议上传JPG格式',
			'default' 	=> '',
			'desc' 		=> '分享图片',
			'match' 	=> 'is_string',
			'update'	=> 'image',
			'key' 		=> '1',
			'place'		=> '150',
			'show'		=> 'share=1',
			//'upload'	=> 'qiniu',
			//'large' 	=> true,
		),

		'share_content'		=> array
		(
			'type' 		=> 'varchar-200',
			'name' 		=> '分享内容',
			'default' 	=> '',
			'desc' 		=> '分享内容',
			'match' 	=> 'option',
			'update'	=> 'textarea',
			'show'		=> 'share=1',
		),

		'reorder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '排序(数值越大越靠前)',
			'default' 	=> '1',
			'desc' 		=> '请输入排序',
			'match' 	=> 'option',
			'update'	=> 'text',
			'search'	=> 'order',
			'list'		=> true,
			'order'		=> 'desc',
			'edit'		=> true,
		),

		'admin_founder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '创建人',
			'default' 	=> '1',
			'desc' 		=> '创建人',
			'match' 	=> 'is_numeric',
		),

		'admin_editor'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '操作人',
			'default' 	=> '1',
			'desc' 		=> '操作人',
			'match' 	=> 'is_numeric',
		),

		'udate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '更新时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
		),

		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),

		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
		),
	),

	'top' => Dever::config('base')->top,

	# 增加这个，为了给当前的list增加一个option $admin = Dever::load('manage/auth.info');
	'top_option' => array
	(
		array
		(
			'value' => $auth,
			'col' => 'cate_id',
		),
		array
		(
			'value' => Dever::load('manage/auth.authData'),
			'col' => 'id',
		),
	),
	
	# 管理功能
	'manage' => array
	(
		//'insert' => false,
		'delete' => false,
		# 列表
		'list_button' => array
		(
			'update' => '编辑',
			'br1' => array('<br />'),
			'edit' => array('预览', str_replace('https://api.', 'http://www.', Dever::url('main/preview.get?type=4'))),
			'br2' => array('<br />'),
			'list10' => array('排行榜', '"magazine_ranking&project=act&search_type=4&search_option_magazine_id={id}&oper_parent=info&oper_project=magazine"' , '{audit} == 1 && {buy} == 1'),
			'add1' => array('排行榜设置', '"ranking&project=magazine&search_option_info_id={id}&oper_parent=info&oper_project=magazine&oper_save_jump=info&where_id={id}"', '{audit} == 1 && {buy} == 1'),

			'list' => array('内页管理', '"content&search_option_info_id={id}&oper_parent=info&page_type=1"' , '{audit} == 1'),
			
			'list1' => array('购买本数管理', '"buy&search_option_info_id={id}&oper_parent=info"' , '{audit} == 1 && {buy} == 1'),
		),
	),

	# request 请求接口定义
	'request' => array
	(

		'search' => array
		(
			# 匹配的正则或函数 选填项
			'option' => array
			(
				'ids' => array('yes-id', 'in'),
				'cate_id' => 'yes',
				'name' => array('yes', 'like'),
				'id' => 'yes',
				'state' => 1,
			),
			'type' => 'all',
			'order' => array('reorder' => 'desc', 'pdate' => 'desc', 'id' => 'desc'),
			'limit' => '0,1000',
			'col' => 'name as name, id, id as value, "" as selected, "" as disabled|id',
		),

		'getAll' => array
		(
			# 匹配的正则或函数 选填项
			'option' => array
			(
				//'audit' => 2,
				'buy' => 'yes',
				'cate_id' => 'yes',
				'status' => 2,
				'state' => 1,
			),
			'type' => 'all',
			'order' => array('reorder' => 'desc', 'pdate' => 'desc', 'id' => 'desc'),
			//'page' => array(10, 'list'),
			'col' => $col,
		),

		'getAllByPage' => array
		(
			# 匹配的正则或函数 选填项
			'option' => array
			(
				//'audit' => 2,
				'cate_id_1' => array('yes-cate_id', '=', 'and('),
				'time' => array('yes-pdate', '<=', 'or)'),
				'buy' => 'yes',
				'cate_id' => 'yes',
				'status' => 2,
				'state' => 1,
			),
			'type' => 'all',
			'order' => array('reorder' => 'desc', 'pdate' => 'desc', 'id' => 'desc'),
			'page' => array(10, 'list'),
			'col' => $col,
		),
		
		# 更新浏览量
		'addView' => array
		(
			'type' => 'update',
			'where' => array
			(
				'id' => 'yes',
			),
			'set' => array
			(
				'num_view' => array('1', '+='),
			),
		),

		# 更新订阅量
		'addDing' => array
		(
			'type' => 'update',
			'where' => array
			(
				'id' => 'yes',
			),
			'set' => array
			(
				'num_up' => array('1', '+='),
			),
		),

		'getIds' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'cate_id' => array('yes-cate_id', 'in'),
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('reorder' => 'desc', 'pdate' => 'desc','id' => 'desc'),
            'col' => '*,id as value|id',
        ),

        'getOne' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'id' => 'yes',
                'state' => 1,
            ),
            'type' => 'one',
            'col' => $col,
        ),

        # 热门
        'getHot' => array
		(
			# 匹配的正则或函数 选填项
			'option' => array
			(
				//'audit' => 2,
				'hot' => 1,
				'buy' => 'yes',
				'time' => array('yes-pdate', '<=', 'or)'),
				'cate_id' => 'yes',
				'status' => 2,
				'state' => 1,
			),
			'type' => 'all',
			'order' => array('reorder' => 'desc', 'pdate' => 'desc', 'id' => 'desc'),
			//'page' => array(10, 'list'),
			'col' => $col,
		),

        'getNew' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
            	'cate_id_1' => array('yes-cate_id', '=', 'and('),
				'time' => array('yes-pdate', '<=', 'or)'),
				'cate_id' => 'yes',
            	'status' => 2,
                'state' => 1,
            ),
            'type' => 'one',
            'order' => array('ssdate' => 'desc'),
            'col' => $col . ',case when cate_id = 1 then pdate else pdate-'.$time.' end as ssdate',
        ),
	),
);

/* 由top_option取代
if ($auth) {
	$config['request']['list'] = array
	(
		'type' => 'all',
        'order' => array('id' => 'desc'),
        'col' => '*|id',
        'page' => array(15, 'list'),
        'option' => array
        (
        	'cate_id' => array($auth, 'in'),
        ),
	);
}
*/

return $config;