<?php

$status = array
(
    1 => '开启',
    2 => '关闭',
);
return array
(
    # 表名
    'name' => 'ranking',
    # 显示给用户看的名称
    'lang' => '排行榜设置',
    'menu' => false,
    'ends' => array
    (
        'insert' => 'magazine/lib/manage.setRankingCache',
        'update' => 'magazine/lib/manage.setRankingCache',
    ),
    # 数据结构
    'struct' => array
    (
    
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'update'    => 'hidden',
            'value'     => Dever::input('where_id')
            //'list'        => true,
        ),

        'info_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '电子刊',
            'default'   => '',
            'desc'      => '电子刊',
            'match'     => 'is_numeric',
            'update'    => 'hidden',
            'value'     => Dever::input('search_option_info_id')
        ),

        'status'     => array
        (
            'type'      => 'int-11',
            'name'      => '排行榜状态',
            'default'   => '1',
            'desc'      => '排行榜状态',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $status,
        ),

        'name'      => array
        (
            'type'      => 'varchar-80',
            'name'      => '排行榜标题',
            'default'   => '',
            'desc'      => '排行榜标题',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),

        'start'       => array
        (
            'type'      => 'int-11',
            'default'   => '',
            'name'      => '排行榜开始时间',
            'match'     => 'option',
            'desc'      => '排行榜开始时间',
            'update'    => 'date',
            'list'      => 'date("Y-m-d H:i:s", {start})',
            'callback'  => 'maketime',
        ),

        'end'       => array
        (
            'type'      => 'int-11',
            'default'   => '',
            'name'      => '排行榜结束时间',
            'match'     => 'option',
            'desc'      => '排行榜结束时间',
            'update'    => 'date',
            'list'      => 'date("Y-m-d H:i:s", {end})',
            'callback'  => 'maketime',
        ),

        'desc'      => array
        (
            'type'      => 'text-255',
            'name'      => '排行榜描述',
            'default'   => '',
            'desc'      => '排行榜描述',
            'match'     => 'option',
            'update'    => 'editor',
            'key'       => 1,
            //'search'  => 'fulltext',
            //'list'        => true,
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '创建时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            'search'    => 'date',
            //'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    'manage' => array
    (

    ),

    'request' => array
    (
        # 获取提交订单超过12个小时
        'getDataByTime' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'end' => array('yes', '<='),
                'ends' => array('yes-end', '>'),
                'state' => 1,
                'status' => 1,
            ),
            'type' => 'all',
            'order' => array('id' => 'desc'),
            'col' => '*',
        ),
    ),
);
